# coding: utf-8

"""
    SnapTrade

    Connect brokerage accounts to your app for live positions and trading

    The version of the OpenAPI document: 1.0.0
    Contact: api@snaptrade.com
    Created by: https://snaptrade.com/
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from snaptrade_client import schemas  # noqa: F401


class ModelPortfolioDetails(
    schemas.DictSchema
):
    """
    This class is auto generated by Konfig (https://konfigthis.com)
    """


    class MetaOapg:
        
        class properties:
        
            @staticmethod
            def model_portfolio() -> typing.Type['ModelPortfolio']:
                return ModelPortfolio
            
            
            class model_portfolio_security(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['ModelPortfolioSecurity']:
                        return ModelPortfolioSecurity
            
                def __new__(
                    cls,
                    arg: typing.Union[typing.Tuple['ModelPortfolioSecurity'], typing.List['ModelPortfolioSecurity']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'model_portfolio_security':
                    return super().__new__(
                        cls,
                        arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'ModelPortfolioSecurity':
                    return super().__getitem__(i)
            
            
            class model_portfolio_asset_class(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['ModelPortfolioAssetClass']:
                        return ModelPortfolioAssetClass
            
                def __new__(
                    cls,
                    arg: typing.Union[typing.Tuple['ModelPortfolioAssetClass'], typing.List['ModelPortfolioAssetClass']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'model_portfolio_asset_class':
                    return super().__new__(
                        cls,
                        arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'ModelPortfolioAssetClass':
                    return super().__getitem__(i)
            __annotations__ = {
                "model_portfolio": model_portfolio,
                "model_portfolio_security": model_portfolio_security,
                "model_portfolio_asset_class": model_portfolio_asset_class,
            }
        additional_properties = schemas.AnyTypeSchema
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["model_portfolio"]) -> 'ModelPortfolio': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["model_portfolio_security"]) -> MetaOapg.properties.model_portfolio_security: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["model_portfolio_asset_class"]) -> MetaOapg.properties.model_portfolio_asset_class: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> MetaOapg.additional_properties: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["model_portfolio"], typing_extensions.Literal["model_portfolio_security"], typing_extensions.Literal["model_portfolio_asset_class"], str, ]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["model_portfolio"]) -> typing.Union['ModelPortfolio', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["model_portfolio_security"]) -> typing.Union[MetaOapg.properties.model_portfolio_security, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["model_portfolio_asset_class"]) -> typing.Union[MetaOapg.properties.model_portfolio_asset_class, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[MetaOapg.additional_properties, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["model_portfolio"], typing_extensions.Literal["model_portfolio_security"], typing_extensions.Literal["model_portfolio_asset_class"], str, ]):
        return super().get_item_oapg(name)

    def __new__(
        cls,
        *args: typing.Union[dict, frozendict.frozendict, ],
        model_portfolio: typing.Union['ModelPortfolio', schemas.Unset] = schemas.unset,
        model_portfolio_security: typing.Union[MetaOapg.properties.model_portfolio_security, list, tuple, schemas.Unset] = schemas.unset,
        model_portfolio_asset_class: typing.Union[MetaOapg.properties.model_portfolio_asset_class, list, tuple, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[MetaOapg.additional_properties, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, bool, None, list, tuple, bytes, io.FileIO, io.BufferedReader, ],
    ) -> 'ModelPortfolioDetails':
        return super().__new__(
            cls,
            *args,
            model_portfolio=model_portfolio,
            model_portfolio_security=model_portfolio_security,
            model_portfolio_asset_class=model_portfolio_asset_class,
            _configuration=_configuration,
            **kwargs,
        )

from snaptrade_client.model.model_portfolio import ModelPortfolio
from snaptrade_client.model.model_portfolio_asset_class import ModelPortfolioAssetClass
from snaptrade_client.model.model_portfolio_security import ModelPortfolioSecurity
